-- this file demonstrates the problem with foreign keys
-- described in the book on pages 54-55.


CREATE TABLE A ( id INTEGER,                  
                 ref INTEGER, 
                 PRIMARY KEY (id) 
--                 ,FOREIGN KEY (ref) REFERENCES B(id)
               ) ENGINE=InnoDB;


CREATE TABLE B ( id INTEGER,                  
                 ref INTEGER, 
                 PRIMARY KEY (id), 
                 FOREIGN KEY (ref) REFERENCES A(id)
               ) ENGINE=InnoDB;

-- put the foreign key constraint back in table A
ALTER TABLE A ADD 
   CONSTRAINT fk
      FOREIGN KEY (ref) REFERENCES B(id);

     
-- these insert statement will all fail, even though both tables exist
--INSERT INTO A VALUES( 1, 2 );
--INSERT INTO A VALUES( 2, 2 );
--INSERT INTO B VALUES( 1, 1 );
--INSERT INTO B VALUES( 2, 1 );

INSERT INTO A VALUES( 1, NULL );
INSERT INTO A VALUES( 2, NULL );
INSERT INTO B VALUES( 1, 1 );
INSERT INTO B VALUES( 2, 1 );

select * from A;
select * from B;

UPDATE A SET ref=2 WHERE id=1;
UPDATE A SET ref=2 WHERE id=2;

select * from A;
select * from B;


-- remove the foreign key constraint from table A
-- so that we can drop the tables
ALTER TABLE A DROP FOREIGN KEY fk;

DROP TABLE IF EXISTS B;
DROP TABLE IF EXISTS A;
